Make WordPress Core


Ignore:
Timestamp:
02/23/2017 08:09:11 PM (9 years ago)
Author:
jnylen0
Message:

REST API: Correctly parse body parameters for DELETE requests.

DELETE was inadvertently omitted from the list of non-POST HTTP methods that should be able to accept body parameters. Parameters passed to DELETE requests as JSON are already parsed correctly; this commit fixes application/x-www-form-urlencoded parameters as well.

Props mnelson4.
Fixes #39933.

File:
1 edited

Legend:

Unmodified
Added
Removed
  • trunk/tests/phpunit/tests/rest-api/rest-request.php

    r39594 r40105  
    204204        }
    205205
     206        public function non_post_http_methods_with_request_body_provider() {
     207                return array(
     208                        array( 'PUT' ),
     209                        array( 'PATCH' ),
     210                        array( 'DELETE' ),
     211                );
     212        }
     213
    206214        /**
    207          * PUT requests don't get $_POST automatically parsed, so ensure that
    208          * WP_REST_Request does it for us.
     215         * Tests that methods supporting request bodies have access to the
     216         * request's body.  For POST this is straightforward via `$_POST`; for
     217         * other methods `WP_REST_Request` needs to parse the body for us.
     218         *
     219         * @dataProvider non_post_http_methods_with_request_body_provider
    209220         */
    210         public function test_parameters_for_put() {
     221        public function test_non_post_body_parameters( $request_method ) {
    211222                $data = array(
    212223                        'foo' => 'bar',
     
    220231                        ),
    221232                );
    222 
    223                 $this->request->set_method( 'PUT' );
     233                $this->request->set_method( $request_method );
    224234                $this->request->set_body_params( array() );
    225235                $this->request->set_body( http_build_query( $data ) );
    226 
    227236                foreach ( $data as $key => $expected_value ) {
    228237                        $this->assertEquals( $expected_value, $this->request->get_param( $key ) );
Note: See TracChangeset for help on using the changeset viewer.